dofile_once("mods/sellhole/files/scripts/util.lua")
dofile_once("data/scripts/gun/gun_actions.lua")

local entity = GetUpdatedEntityID()
local player = get_player()

self_x, self_y = EntityGetTransform(entity)
dist = 1000
player_x, player_y = EntityGetTransform(player)
if player_x then
  dist = math.sqrt((self_x-player_x)^2 + (self_y-player_y)^2)
end
if dist < 600 then
  wands = EntityGetInRadiusWithTag(self_x, self_y, 40, "wand")
  spells = EntityGetInRadiusWithTag(self_x, self_y, 40, "card_action")
  items = table_concat(wands, spells)
  for _, item in ipairs(items) do
    cost_component = EntityGetFirstComponent(item, "ItemCostComponent")
    if not cost_component then
      a, b = get_entity_velocity(item)
      if a then
        self_x, self_y = EntityGetTransform(entity)
        x, y = EntityGetTransform(item)
        distance = math.sqrt((self_x - x)^2 + (self_y - y)^2)
        angle = math.atan2(self_y - y, self_x - x)
        mod_entity_velocity(item, math.cos(angle) * (50 - distance) / 2, math.sin(angle) * (50 - distance) / 2)
        if math.sqrt((self_x - x)^2 + (self_y - y)^2) < 8 + math.sqrt(a^2+b^2) / 50 then
          coin = 0
          -- debug_entity(item)
          var_comp = EntityGetFirstComponent(entity, "VariableStorageComponent")
          biomeid = ComponentGetValue2(var_comp, "value_int")
          sell_factor = math.max(biomeid, 1)^2 
          if EntityHasTag(item, "wand") then
            wand_level = math.max(biomeid^2 - 1, 0)
            coin = 10 + wand_level * 42
            children = EntityGetAllChildren(item)
            if children then
              for _, child in ipairs(children) do
                comps = EntityGetAllComponents(child)
                for _, comp in ipairs(comps) do
                  if ComponentGetTypeName(comp) == "ItemActionComponent" then
                    action_id = ComponentGetValue2(comp, "action_id")
                    for _, action in ipairs(actions) do
                      if action.id == action_id then
                        price = math.max(math.floor( ( (action.price * 0.30) + (70 * sell_factor) ) / 10 ) * 10, 10)
                        coin = coin + math.max(price / 5, 10)
                      end
                    end
                  end
                end
              end
            end
          elseif EntityHasTag(item, "card_action") then
            comps = EntityGetAllComponents(item)
            for _, comp in ipairs(comps) do
              if ComponentGetTypeName(comp) == "ItemActionComponent" then
                action_id = ComponentGetValue2(comp, "action_id")
                for _, action in ipairs(actions) do
                  if action.id == action_id then
                    price = math.max(math.floor( ( (action.price * 0.30) + (70 * sell_factor) ) / 10 ) * 10, 10)
                    coin = coin + math.max(price / 5, 10)
                  end
                end
              end
            end
          end
          drop_sell_gold(self_x, self_y, coin, a, b)
          if coin > 500 then
            shoot_projectile( entity, "data/entities/particles/gold_pickup_huge.xml", self_x, self_y, 0, 0 )
          elseif coin > 40 then
            shoot_projectile( entity, "data/entities/particles/gold_pickup_large.xml", self_x, self_y, 0, 0 )
          else
            shoot_projectile( entity, "data/entities/particles/gold_pickup.xml", self_x, self_y, 0, 0 )
          end
          EntityKill(item)
          sprite = EntityGetFirstComponent(entity, "SpriteComponent")
          if sprite then
            ComponentSetValue2(sprite, "rect_animation", "flash")
            ComponentSetValue2(sprite, "next_rect_animation", "loop")
          end
        end
      end
    end
  end
end
